DEFINE CLASS sesFolders As Session
	bCountOnly = .F.
	*
	cFirstChar = '_' 	&& ''
	nFirstCharLen = 1 	&& 0
	*
	cCursorFolders = ''
	nCountFolders = 0
	cCurrentFolder = ''
	cCursorRefs = ''
	*
	cCursorFiles = ''
	nCountFiles = 0
	cCurrentFile = ''
	
	PROCEDURE cFirstChar_Assign
		LPARAMETERS tcNewValue
		IF VARTYPE(tcNewValue) = 'C'
			WITH this
				.cFirstChar = tcNewValue
				.nFirstCharLen = LENC(.cFirstChar)
			ENDWITH	
		ENDIF	
	ENDPROC

	PROCEDURE Destroy
		WITH this
			.CloseCursorFiles()
			.CloseCursorFolders()
		ENDWITH	
	ENDPROC

	*
	*-- Folders
	PROCEDURE cCurrentFolder_Assign 
		LPARAMETERS tcNewValue
		IF VARTYPE(tcNewValue) = 'C'
			this.cCurrentFolder = tcNewValue
		ENDIF	
	ENDPROC

	FUNCTION CreateCursorFolders
		WITH this
			LOCAL lnOldSel as Number;
				,lcAliasFolders as String;
				,lcAliasRefs as String
			lnOldSel = SELECT()  
			.CloseCursorFolders()
			*
			lcAliasFolders = '_' + SUBSTR(SYS(2015),2)
			CREATE CURSOR (lcAliasFolders) (id I UNIQUE, name M)
			IF !USED(lcAliasFolders)
				SELECT (lnOldSel)
				RETURN .F.
			ENDIF
			*
			lcAliasRefs = '_' + SUBSTR(SYS(2015),2)
			CREATE CURSOR (lcAliasRefs) (id I UNIQUE, pid I)
			IF !USED(lcAliasRefs)
				SELECT (lnOldSel)
				RETURN .F.
			ENDIF
			*
			.cCursorFolders = lcAliasFolders
			.cCursorRefs = lcAliasRefs
			.nCountFolders = 0
			.cCurrentFolder = ''
			SELECT (lnOldSel)
		ENDWITH
	ENDFUNC  

	PROCEDURE CloseCursorFolders
		WITH this
			IF !EMPTY(.cCursorRefs) AND USED(.cCursorRefs)
				USE IN (.cCursorRefs)
				IF !USED(.cCursorRefs) AND !USED(.cCursorRefs)
					.cCursorRefs = ''
				ENDIF
			ENDIF
			IF !EMPTY(.cCursorFolders) AND USED(.cCursorFolders)
				USE IN (.cCursorFolders)
				IF !USED(.cCursorFolders) AND !USED(.cCursorRefs)
					.nCountFolders = 0
					STORE '' TO .cCurrentFolder, .cCursorFolders
				ENDIF	
			ENDIF
			RETURN !USED(.cCursorFolders) AND !USED(.cCursorRefs)
		ENDWITH
	ENDPROC

	PROCEDURE FillCursorFolders
		LPARAMETERS tcRootFolder, tnParentId 
		IF VARTYPE(tcRootFolder) # 'C'
			RETURN .F.
		ENDIF
		IF EMPTY(tcRootFolder)
			tcRootFolder = LOWER(FULLPATH(CURDIR()))
		ENDIF
		IF !DIRECTORY(tcRootFolder)
			RETURN .F.
		ENDIF
		IF EMPTY(this.cCursorFolders)
			IF !this.CreateCursorFolders()
				RETURN .F.
			ENDIF
			IF VARTYPE(tnParentId) # 'N'
				tnParentId = 1
			ENDIF	
		ENDIF
		IF !USED(this.cCursorFolders)
			RETURN .F.
		ENDIF
		IF VARTYPE(tnParentId) # 'N'
			RETURN .F.
		ENDIF
		LOCAL lnCnt as Number;
			,lnMax as Integer;
			,lnParentId as Number; 
			,lcCurName as String;
			,lcCurFolder as String;
			,lbIsSkipChat as Boolean
		lbIsSkipChat = !EMPTY(this.cFirstChar)
		lcCurFolder = ADDBS(ALLTRIM(tcRootFolder))
		lnParentId = tnParentId
		WITH this
			.nCountFolders = .nCountFolders + 1
			.cCurrentFolder = lcCurFolder
			IF !.bCountOnly
				INSERT INTO (.cCursorFolders) (id, name) ;
					VALUES (.nCountFolders, lcCurFolder)
				INSERT INTO (.cCursorRefs) (id, pid) ;
					VALUES (.nCountFolders, lnParentId)
			ENDIF	
			lnParentId = .nCountFolders
		ENDWITH
		LOCAL ARRAY laDir[1]
		lnMax = ADIR(laDir, lcCurFolder + '*', 'D', 1)
		FOR lnCnt =  1 TO lnMax
			lcCurName = laDir[lnCnt,1]
			IF lbIsSkipChat AND ;
					SUBSTR(lcCurName, 1, this.nFirstCharLen) = this.cFirstChar
				LOOP
			ENDIF
			IF 'D' $ laDir[lnCnt,5] AND !(lcCurName = '.' OR lcCurName = '..')
				this.FillCursorFolders(lcCurFolder + lcCurName, lnParentId)
			ENDIF
		ENDFOR 
	ENDPROC

	*
	*-- Files
	PROCEDURE cCurrentFile_Assign 
		LPARAMETERS tcNewValue
		IF VARTYPE(tcNewValue) = 'C'
			this.cCurrentFile = tcNewValue
		ENDIF	
	ENDPROC

	FUNCTION CreateCursorFiles
		WITH this
			LOCAL lcAlias as String, lnOldSel as Number
			lnOldSel = SELECT()  
			.CloseCursorFiles()
			lcAlias = '_' + SUBSTR(SYS(2015),2)
			CREATE CURSOR (lcAlias) ;
				(id I UNIQUE, name M, size I, date D, time C(8), attributes C(11))
			IF !USED(lcAlias)
				SELECT (lnOldSel)
				RETURN .F.
			ENDIF
			.cCursorFiles = lcAlias
			.nCountFiles = 0
			.cCurrentFile = ''
			SELECT (lnOldSel)
		ENDWITH
	ENDFUNC  

	PROCEDURE CloseCursorFiles
		WITH this
			IF !EMPTY(.cCursorFiles) AND USED(.cCursorFiles)
				USE IN (.cCursorFiles)
				IF !USED(.cCursorFiles)
					.nCountFiles = 0
					STORE '' TO ;
						.cCurrentFile, .cCursorFiles
				ENDIF	
			ENDIF
			RETURN !USED(.cCursorFiles)
		ENDWITH
	ENDPROC

	PROCEDURE FillCursorFiles
		LPARAMETERS tcFolder, tcAttribute
		IF VARTYPE(tcFolder) # 'C'
			RETURN .F.
		ENDIF
		IF EMPTY(tcFolder)
			tcFolder = LOWER(FULLPATH(CURDIR()))
		ENDIF
		IF !DIRECTORY(tcFolder)
			RETURN .F.
		ENDIF
		IF EMPTY(this.cCursorFiles)
			IF !this.CreateCursorFiles()
				RETURN .F.
			ENDIF
		ENDIF
		IF !USED(this.cCursorFiles)
			RETURN .F.
		ENDIF
		IF VARTYPE(tcAttribute) # 'C'
			tcAttribute = 'D'
		ENDIF
		LOCAL lnCnt as Number;
			,lnMax as Integer;
			,lcCurName as String;
			,lcCurFolder as String;
			,lbIsSkipChat as Boolean
		lbIsSkipChat = !EMPTY(this.cFirstChar)
		lcCurFolder = ADDBS(ALLTRIM(tcFolder))
		LOCAL ARRAY laDir[1]
		lnMax = ADIR(laDir, lcCurFolder + '*', tcAttribute, 1)
		WITH this
			FOR lnCnt =  1 TO lnMax
				IF 'D' $ laDir[lnCnt,5]
					LOOP
				ENDIF
				lcCurName = laDir[lnCnt,1]
				IF lbIsSkipChat AND SUBSTR(lcCurName, 1, .nFirstCharLen) = .cFirstChar
					LOOP
				ENDIF
				.nCountFiles = .nCountFiles + 1
				IF !.bCountOnly
					INSERT INTO (.cCursorFiles) (id, name, size, date, time, attributes) ;
						VALUES (.nCountFiles, lcCurName;
							,laDir[lnCnt,2], laDir[lnCnt,3], laDir[lnCnt,4], laDir[lnCnt,5])
				ENDIF
				.cCurrentFile = lcCurName
			ENDFOR 
		ENDWITH
	ENDPROC

ENDDEFINE